from math import *

import operator

def distance(v1,v2):
    return abs(v1-v2)

def squared_distance(v1,v2):
    diff = v1-v2
    return dot(diff,diff)

def angle(v1,v2):
    return acos(v1.normalize() * v2.normalize())

class vecn():#n-dimensional vector
    data = [0,0,0]
    def __init__(self,*data):
        if len(data) > 1:
            self.data = data
        else:
            self.data = data[0]
   # def __init__(self,x,y,z):
   #     self.data = (x,y,z)
    def get_x(self):
        return self.data[0]
    def get_y(self):
        return self.data[1]
    def get_z(self):
        return self.data[2]
    def set_x(self,new_x):
        self.data[0] = new_x
        return new_x
    def set_y(self,new_y):
        self.data[1] = new_y
        return new_y
    def set_z(self,new_z):
        self.data[2] = new_z
        return new_z
    x =property(get_x,set_x)
    y =property(get_y,set_y)
    z =property(get_z,set_z)

    def __add__(self,v):
        return vecn(map(operator.add,self.data,v.data))
    def __sub__(self,v):
        return vecn(map(operator.sub,self.data,v.data))
    def scale(self,a): #wie kann ich 3 * v schreiben?
        return vecn(map(lambda x : x*a,self.data))
    def __abs__(self):
        return sqrt(dot(self,self))
    def normalize(self,length = 1):
        return self.scale(length / abs(self))
    def __repr__(self):
        return str(self.data)
    def rotate(self,newangle):
        oldangle = atan2(self.x,self.y) #weird, faengt bei (0,1) an statt (1,0) 
        oldlength = abs(self) + 0
        return vecn(sin(newangle+oldangle)*oldlength,cos(newangle+oldangle)*oldlength)



def dot(v1,v2):
    return reduce(operator.add,map(operator.mul,v1.data,v2.data))
'''
def distance(v1,v2):
    return abs(v1-v2)

def angle(v1,v2):
    return acos(dot(v1.normalize(),v2.normalize()))


class v_sphere(vec3):
    direction_normal = 0 #normal of the plane that contains the circle the vector moves on
    def get_direction(self):
        pass #todo
    def set_direction(self,new_direction):
        pass #todo
    direction = property (get_direction, set_direction)
    #direction: 0 = towards pole, pi = away from pole, pi/2 = tangential zu einem breitengrad
    speed = 0 # angular speed per frame
    def set_direction_target(self,v): #set direction so that self will hit v eventually
        pass #todo
    


def spherical_distance (v1,v2):
    assert abs(v1) == abs (v2)
    return 2 * pi * angle(v1,v2)

def spherical_linear_combination (v1,v2,bias):
    pass #todo
'''

    
'''
class vec3_spherical():
    _radius = 1
    _alpha = 0
    _phi = 0
    def to_cartesian(self):
'''
